#pragma once

#include "common.h"
#include <glew.h>

#include <windows.h>
#include <stdlib.h>
#include <io.h>
#include <glew.h>
#include "Vector.h"


//!AbstractShader class
/*!
 * Diese Klasse stellt Hilfsfunktionen zur Verwaltung der Shader zur Verfgung. 
 * @author Michael Beham
 * @date 5.12.2010
*/
class AbstractShader
{
public:
	/*!
	* Diese FUnktion liest den Shader aus einer Textdatei.
	* @param [in] *fn Pfad zum Shader
	* @return Code des Shaders.
	*/
	char* textFileRead(char *fn) 
	{
		FILE *fp;
		char *content = NULL;
		int count=0;

		if (fn != NULL) 
		{
			fp = fopen(fn,"rt");
			if (fp != NULL) 
			{
				fseek(fp, 0, SEEK_END);
				count = ftell(fp);
				rewind(fp);

				if (count > 0) 
				{
					content = (char *)malloc(sizeof(char) * (count+1));
					count = fread(content,sizeof(char),count,fp);
					content[count] = '\0';
				}
				fclose(fp);
			}
		}
		return content;
	};

	/*!
	 * Diese Funktion ladedt den Shader und erstellt diesem.
	 * @param [in] filename Pfad zum Shader.
	 * @param [in type des Shaders
	 * @return ID des Shaders
	 */
	GLhandleARB loadShader(const char* filename, unsigned int type)
	{
		FILE *pfile;
		GLhandleARB handle;
		const GLcharARB* files[1];
		GLint result;			
		GLint errorLoglength ;
		char* errorLogText;
		GLsizei actualErrorLogLength;
		char buffer[400000];
		memset(buffer,0,400000);
	
		pfile = fopen(filename, "rb");
		if(!pfile)
		{
			printf("Shader konnte nicht geffnet werden '%s'.\n", filename);
			//exit(0);
		}
	
		fread(buffer,sizeof(char),400000,pfile);
		fclose(pfile);
	
		handle = glCreateShaderObjectARB(type);
		if (!handle)
		{
			printf("Shader konte nicht erstellt werden: %s.",filename);
			//exit(0);
		}

		files[0] = (const GLcharARB*)buffer;
		glShaderSourceARB(handle, 1, files, NULL);	
		glCompileShaderARB(handle);
		glGetObjectParameterivARB(handle, GL_OBJECT_COMPILE_STATUS_ARB, &result);
	
		if (!result)
		{
			printf("Shader '%s' konnte nicht kompeliert werden.\n",filename);
			glGetObjectParameterivARB(handle, GL_OBJECT_INFO_LOG_LENGTH_ARB, &errorLoglength);
			errorLogText = (char*) malloc(sizeof(char) *errorLoglength);
			glGetInfoLogARB(handle, errorLoglength, &actualErrorLogLength, errorLogText);
			printf("%s\n",errorLogText);
			free(errorLogText);
		}
		return handle;
	};
};
