#pragma once

#include "Vector.h"
#include "states.h"

//! Camera class
/*!
 * Diese Klasse ist eine Container Funktion, welche Attribute zum Setzen der Kamera speichert.
 */
class Camera 
{
public:
	/*!
	 * Standardkonstruktor: Setzt Werte auf Default Werte
	 */
	Camera() 
	{
		m_viewpos = Vector(0.0f,0.0f,-1.0f);
		m_viewtarget = Vector(0.0f,0.0f,0.0f);
	};
	
	/*!
	 * Konstruktor: Setzt die Werte:
	 * @param [in] viewpos Punkt des Betrachters
	 * @param [in] viewtarget Zielpunkt des Betrachters
	 */
	Camera(Vector viewpos, Vector viewtarget) 
	{
		m_viewpos = viewpos;
		m_viewtarget = viewtarget;
	};
	
	/*!
	 * Dekonstruktor
	 */
	~Camera() 
	{
		
	};

//private:
	Vector m_viewpos;
	Vector m_viewtarget;
	
	int slidemode;

	float startviewportx;
	float startviewporty;
	float viewportx;
	float viewporty;

	float rotx;
	float roty;

	States::Display m_Type;
};