#include "LoadTramsferFunction.h"

LoadTramsferFunction::LoadTramsferFunction(const char* file) : LoadData(file)
{
	std::cout << "****" << " " << "****" << std::endl;
	failedLoading = false;
	if (loadOkay)	loadingTag(&doc,0);
	else			failedLoading = true;
}

LoadTramsferFunction::~LoadTramsferFunction()
{
	std::cout << "LOAD SOUND " << std::endl;

}

void LoadTramsferFunction::loadingTag(TiXmlNode* pParent, unsigned int indent)
{
	if ( !pParent ) return;

	TiXmlNode* pChild;
	TiXmlText* pText;
	int t = pParent->Type();
	int num;
	
	const std::string point = "Point";

	switch ( t )
	{
		case TiXmlNode::TEXT:
			pText = pParent->ToText();
		break;

		case TiXmlNode::ELEMENT:
		{
			if(pParent->Value() == point)
			{
				this->points.resize(this->points.size()+1);
				this->points[this->points.size()-1] = TFContainer();
			}

			num=attribsLoading(pParent->ToElement(), indent+1);
			
			break;
		}
		default: break;
	}
	for ( pChild = pParent->FirstChild(); pChild != 0; pChild = pChild->NextSibling()) 
	{
		loadingTag( pChild, indent+1 );
	}
}

int LoadTramsferFunction::attribsLoading(TiXmlElement* pElement, unsigned int indent)
{
	if ( !pElement ) return 0;

	TiXmlAttribute* pAttrib=pElement->FirstAttribute();

	double dval;
	const std::string x = "x";
	const std::string y = "y";
	const std::string r = "r";
	const std::string g = "g";
	const std::string b = "b";

	int i=0;
	const char* pIndent=getIndent(indent);
	
	while (pAttrib)
	{
		const char* attr = pAttrib->Name();

		if(attr == x && pAttrib->QueryDoubleValue(&dval)==TIXML_SUCCESS)	this->points[this->points.size()-1].SetX(dval);
		if(attr == y && pAttrib->QueryDoubleValue(&dval)==TIXML_SUCCESS)	this->points[this->points.size()-1].SetY(dval);
		if(attr == r && pAttrib->QueryDoubleValue(&dval)==TIXML_SUCCESS)	this->points[this->points.size()-1].SetR(dval);
		if(attr == g && pAttrib->QueryDoubleValue(&dval)==TIXML_SUCCESS)	this->points[this->points.size()-1].SetG(dval);
		if(attr == b && pAttrib->QueryDoubleValue(&dval)==TIXML_SUCCESS)	this->points[this->points.size()-1].SetB(dval);

		i++;
		pAttrib=pAttrib->Next();
	}
	return 0;	
}

vector<TFContainer> LoadTramsferFunction::GetPoints()
{
	return points;
}